//*******************************************************
//@@ohbPUePWQR gdw@Vϊ\vO
//     PIC16F1823 hex to 7seg Display Program
//  file name: main.c
//@@@S̃XCb`̐MPUiƂāAVZOkdcɕ\
//        4-switch(hexdecimal) to 7seg. Display 
//@@@PA0:7seg.-g     1=Lighting
//@@@PA1:7seg.-dp    1=Lighting
//@@@PA2:Switch1-B0
//@@@PA3:Switch2-B1  vOގɂ͕KuPv̈ʒuɂ鎖iȂƏ߂Ȃj
//@@@PA4:Switch3-B2
//@@@PA5:Switch4-B3
//@@@PC0:7seg.-a     1=Lighting
//@@@PC1:7seg.-b     1=Lighting
//@@@PC2:7seg.-c     1=Lighting
//@@@PC3:7seg.-d     1=Lighting
//@@@PC4:7seg.-e     1=Lighting
//@@@PC5:7seg.-f     1=Lighting
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2014/01/25  New(TAB4)  Taishi
//*******************************************************

#include	<htc.h>

#define	_XTAL_FREQ	32000000L	//	giWlgS{j

// CONFIG for 16F1823

__CONFIG (	FCMEN_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	IESO_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	CLKOUTEN_OFF		//	1(OFF) = CLKOUT@\𖳌ɂBCLKOUT sI/O Ƃċ@\
		&	BOREN_ON			//	11 = BOR(uEAEgZbg)Lɂ
		&	CPD_OFF				//	1(OFF) = f[^̃R[hی𖳌ɂ
		&	CP_OFF				//	1(OFF) = vÕR[hی𖳌ɂ
		&	MCLRE_OFF			//	0(OFF) = MCLR/VPP s̓fW^͂Ƃċ@\B
		&	PWRTE_ON			//	0 = PWRT(p[Abv^C}[)Lɂ
		&	WDTE_OFF			//	00 = WDT(EHb`hbO^C}[)𖳌ɂ
		&	FOSC_INTOSC			//	100 = INTOSCIV[^:CLKIN sI/O Ƃċ@\
);

								//	fobO@\͏ݑuɔCij

__CONFIG (	LVP_OFF				//	0(OFF)=vO~OMCLR ɍdKv
		&	BORV_LO				//	1 = uEAEgZbgd(Vbor)̃gbv|Cgɐݒ肷
		&	STVREN_ON			//	1(ON) = X^bÑI[o[t[܂̓A_[t[ɂăZbg𔭐
		&	PLLEN_ON			//	1 = 4xPLL Lɂ
		&	WRT_OFF				//	11 = ݕیOFF ɂ
);

const unsigned char	hex_to_7seg[16]={
		// D7;dp, D6:g, D5:f, D4:e, D3:d, D2:c, D1:b, D0:a
		0b00111111,				// 0
		0b00000110,				// 1
		0b01011011,				// 2
		0b01001111,				// 3
		0b01100110,				// 4
		0b01101101,				// 5
		0b01111101,				// 6
		0b00000111,				// 7
		0b01111111,				// 8
		0b01101111,				// 9
		0b01110111,				// A
		0b01111100,				// B
		0b01011000,				// C
		0b01011110,				// D
		0b01111001,				// E
		0b01110001,				// F
};

// *****************************
//  PUif[^̓
//  @F
//  ߂lFPUi
//
//  \߃|[g̐ݒ͍sĂ̂Ƃ
//  2014/01/25 New   Taishi
// *****************************
static
unsigned char	get_hexdecimal(void)
{
	unsigned char	h=0;	// ͂PUi

	if(RA2 == 0){			// RA2(B0) Input
		;
	}else{
		h |= 1;
	}

	if(RA3 == 0){			// RA3(B1) Input
		;
	}else{
		h |= 2;
	}

	if(RA4 == 0){			// RA4(B2) Input
		;
	}else{
		h |= 4;
	}

	if(RA5 == 0){			// RA5(B3) Input
		;
	}else{
		h |= 8;
	}

	return(h);
}

// *****************************
//  VZȌo
//  @
//@@@@FPUiiO`PTj
//@@@F̏ԁ@OAP_
//
//  \߃|[g̐ݒ͍sĂ̂Ƃ
//  2014/01/25 New   Taishi
// *****************************
static
void output_7seg(unsigned char h, unsigned char dp)
{
	unsigned char	seg;

	seg = hex_to_7seg[h & 0x0f];	// PUiVZOf[^ɕϊ

	if((seg & 0x01) == 0){			// 7seg -a
		RC0 = 0;
	}else{
		RC0 = 1;
	}

	if((seg & 0x02) == 0){			// 7seg -b
		RC1 = 0;
	}else{
		RC1 = 1;
	}

	if((seg & 0x04) == 0){			// 7seg -c
		RC2 = 0;
	}else{
		RC2 = 1;
	}

	if((seg & 0x08) == 0){			// 7seg -d
		RC3 = 0;
	}else{
		RC3 = 1;
	}

	if((seg & 0x10) == 0){			// 7seg -e
		RC4 = 0;
	}else{
		RC4 = 1;
	}

	if((seg & 0x20) == 0){			// 7seg -f
		RC5 = 0;
	}else{
		RC5 = 1;
	}

	if((seg & 0x40) == 0){			// 7seg -g
		RA0 = 0;
	}else{
		RA0 = 1;
	}

	if(dp == 0){					// 7seg -dp
		RA1 = 0;
	}else{
		RA1 = 1;
	}

}

// *****************************
//	main
//
//  2014/01/25 New   Taishi
// *****************************
void	main(void)
{
	unsigned char	i;
	unsigned char	h;			// ͂PUi
	unsigned char	hh;			// fobOp̂PUi
	unsigned char	dp;			// dp _(1)@(0)

	di();						//	荞݋֎~

//				    76543210
	OSCCON	    = 0b01110000;		//	NbNWlg@c@okkHLȂ̂ŎRQlg

	OPTION_REG &= 0b01111111;		// Ŝ̃vAbvLɂ

//				    76543210		//  |[g`
	ANSELA	    = 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTA	    = 0b00000000;		//	o̓f[^ݒ(SĂO)
	TRISA	    = 0b00111100;		//	o͕ݒ(RA0,1:OutputARA2,3,4,5:Input)
	WPUA	    = 0b00111100;		//	vAbvݒ(RA2,3,4,5:Pullup)


//				    76543210		//  |[gb
	ANSELC	    = 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTC	    = 0b00000000;		//	o̓f[^ݒ(SĂO)
	TRISC	    = 0b00000000;		//	o͕ݒ(Sďo)
	WPUC	    = 0b00000000;		//	vAbvݒ(SăvAbv)

	for(i=0;i<10;i++){
		PORTA ^= 2;				//  LED ON or OFF
		__delay_ms(500);		//	TOOҋ@;
	}


	i = 0;
	hh = 0;
	while(1){
		__delay_ms(50);			//	TOҋ@;
 		h = get_hexdecimal();	//  PUif[^̓
		i++;
		if(20 <= i){
			i = 0;
			hh++;				// debug
			hh &= 0x0f;			// debug
		}
		if(i < 10){				//@̓_(50msx10=500ms ɓ_AJԂj
			dp = 1;				//  _
		}else{
			dp = 0;				//@
		}
//		h = hh;					// debug
 		output_7seg(h,dp);		//  VZȌo
	}
}
